﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="jQueryAutocompleteWithWcf.Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>jQuery UIs Autocomplete with WCF</title>
    <style type="text/css">
        body { font-size:.7em; margin:40px; }
    </style>

    <link rel="Stylesheet" href="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8/themes/base/jquery-ui.css" />
    <link rel="Stylesheet" href="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.5/themes/dot-luv/jquery-ui.css" />
    <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4.3/jquery.min.js"></script>
    <script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.5/jquery-ui.min.js"></script>
    <script type="text/javascript">
        $(document).ready(function () {
            var makesCache = {}, modelsCache = {}, makesXhr, modelsXhr;

            $('#Makes').autocomplete({
                source: function (request, response) {
                    var term = request.term;
                    if (term in makesCache) {
                        response(makesCache[term]);
                        return;
                    }
                    if (makesXhr != null) {
                        makesXhr.abort();
                    }
                    makesXhr = $.getJSON('AutomobileService.svc/GetMakes', request, function (data, status, xhr) {
                        makesCache[term] = data.d;
                        if (xhr == makesXhr) {
                            response(data.d);
                            makesXhr = null;
                        }
                    });
                }
            });

            $('#Models').autocomplete({
                source: function (request, response) {
                    var term = request.term;
                    if (term in modelsCache) {
                        response(modelsCache[term]);
                        return;
                    }
                    if (modelsXhr != null) {
                        modelsXhr.abort();
                    }
                    modelsXhr = $.getJSON('AutomobileService.svc/GetModels', request, function (data, status, xhr) {
                        modelsCache[term] = data.d;
                        if (xhr == modelsXhr) {
                            response(data.d);
                            modelsXhr = null;
                        }
                    });
                }
            });
        });
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <h1>ASP.NET Sample</h1>
        <h2>Using jQuery UI's Autocomplete with WCF</h2>

        Makes: <input id="Makes" />

        Models: <input id="Models" />
    </div>
    </form>
</body>
</html>
